<?php

namespace RecruitCrm\LogicMelon\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAPIAdvertWithPostings ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAPIAdvertWithPostings
 * @subpackage Arrays
 */
class ArrayOfAPIAdvertWithPostings extends AbstractStructArrayBase
{
    /**
     * The APIAdvertWithPostings
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings[]
     */
    public $APIAdvertWithPostings;
    /**
     * Constructor method for ArrayOfAPIAdvertWithPostings
     * @uses ArrayOfAPIAdvertWithPostings::setAPIAdvertWithPostings()
     * @param \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings[] $aPIAdvertWithPostings
     */
    public function __construct(array $aPIAdvertWithPostings = array())
    {
        $this
            ->setAPIAdvertWithPostings($aPIAdvertWithPostings);
    }
    /**
     * Get APIAdvertWithPostings value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings[]|null
     */
    public function getAPIAdvertWithPostings()
    {
        return isset($this->APIAdvertWithPostings) ? $this->APIAdvertWithPostings : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAPIAdvertWithPostings method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAPIAdvertWithPostings method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAPIAdvertWithPostingsForArrayConstraintsFromSetAPIAdvertWithPostings(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAPIAdvertWithPostingsAPIAdvertWithPostingsItem) {
            // validation for constraint: itemType
            if (!$arrayOfAPIAdvertWithPostingsAPIAdvertWithPostingsItem instanceof \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings) {
                $invalidValues[] = is_object($arrayOfAPIAdvertWithPostingsAPIAdvertWithPostingsItem) ? get_class($arrayOfAPIAdvertWithPostingsAPIAdvertWithPostingsItem) : sprintf('%s(%s)', gettype($arrayOfAPIAdvertWithPostingsAPIAdvertWithPostingsItem), var_export($arrayOfAPIAdvertWithPostingsAPIAdvertWithPostingsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The APIAdvertWithPostings property can only contain items of type \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set APIAdvertWithPostings value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings[] $aPIAdvertWithPostings
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfAPIAdvertWithPostings
     */
    public function setAPIAdvertWithPostings(array $aPIAdvertWithPostings = array())
    {
        // validation for constraint: array
        if ('' !== ($aPIAdvertWithPostingsArrayErrorMessage = self::validateAPIAdvertWithPostingsForArrayConstraintsFromSetAPIAdvertWithPostings($aPIAdvertWithPostings))) {
            throw new \InvalidArgumentException($aPIAdvertWithPostingsArrayErrorMessage, __LINE__);
        }
        if (is_null($aPIAdvertWithPostings) || (is_array($aPIAdvertWithPostings) && empty($aPIAdvertWithPostings))) {
            unset($this->APIAdvertWithPostings);
        } else {
            $this->APIAdvertWithPostings = $aPIAdvertWithPostings;
        }
        return $this;
    }
    /**
     * Add item to APIAdvertWithPostings value
     * @throws \InvalidArgumentException
     * @param \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings $item
     * @return \RecruitCrm\LogicMelon\ArrayType\ArrayOfAPIAdvertWithPostings
     */
    public function addToAPIAdvertWithPostings(\RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings) {
            throw new \InvalidArgumentException(sprintf('The APIAdvertWithPostings property can only contain items of type \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->APIAdvertWithPostings[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \RecruitCrm\LogicMelon\StructType\APIAdvertWithPostings|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string APIAdvertWithPostings
     */
    public function getAttributeName()
    {
        return 'APIAdvertWithPostings';
    }
}
